;
;	Additional runtime support routines for DOS.
;	Copyright (C) 1997 Nils M. Holm.
;
	.model small
	.code
	public	_pack, _unpack, _pack_, _unpack_
	public	__exit, _length
	public	_creat, _open, _close, _read, _write, _unlink, _lseek
_pack_:
_pack:	push	bp
	mov	bp,sp
	push	si
	push	di
	mov	si,[bp+6]
	mov	di,[bp+4]
	mov	dx,di
	cld
pknext:	lodsw
	stosb
	or	ax,ax
	jnz	pknext
	sub	di,dx
	inc	di
	shr	di,1
	mov	ax,di
	pop	di
	pop	si
	pop	bp
	ret
_unpack_:
_unpack:push	bp
	mov	bp,sp
	push	si
	push	di
	mov	si,[bp+6]
	mov	di,[bp+4]
	mov	dx,si
	cld
upknext:lodsb
	xor	ah,ah
	stosw
	or	ax,ax
	jnz	upknext
	sub	si,dx
	mov	ax,si
	pop	di
	pop	si
	pop	bp
	ret
__exit:	mov	bp,sp
	mov	ax,[bp+2]
	mov	ah,4Ch
	int	21h
;	ret		; we'll hopefully never get here...
_length:push	bp
	mov	bp,sp
	push	di
	mov	di,[bp+4]
	mov	dx,di
	cld
	xor	ax,ax
	xor	cx,cx
	dec	cx
	repnz	scasw
	sub	di,dx
	shr	di,1
	dec	di
	mov	ax,di
	pop	di
	pop	bp
	ret
_creat:	push	bp
	mov	bp,sp
	mov	ax,3C00h
	mov	dx,[bp+4]
	xor	cx,cx
	int	21h
	jc	ioerr
	pop	bp
	ret
_open:	push	bp
	mov	bp,sp
	mov	ax,[bp+6]
	or	ax,3D00h
	mov	dx,[bp+4]
	int	21h
	jc	ioerr
	pop	bp
	ret
_close:	push	bp
	mov	bp,sp
	mov	ax,3E00h
	mov	bx,[bp+4]
	int	21h
	jc	ioerr
	xor	ax,ax
	pop	bp
	ret
_unlink:push	bp
	mov	bp,sp
	mov	ax,4100h
	mov	dx,[bp+4]
	int	21h
	jc	ioerr
	pop	bp
	ret
_read:	push	bp
	mov	bp,sp
	mov	ax,3F00h
	mov	bx,[bp+4]
	mov	dx,[bp+6]
	mov	cx,[bp+8]
	int	21h
	jc	ioerr
	pop	bp
	ret
_write:	push	bp
	mov	bp,sp
	mov	ax,4000h
	mov	bx,[bp+4]
	mov	dx,[bp+6]
	mov	cx,[bp+8]
	int	21h
	jc	ioerr
	pop	bp
	ret
ioerr:	mov	ax,-1
	pop	bp
	ret
_lseek:	push	bp
	mov	bp,sp
	mov	ax,4202h
	mov	bx,[bp+4]
	xor	cx,cx
	xor	dx,dx
	int	21h
	jc	ioerr
	pop	bp
	ret
	end
